summaryrefslogtreecommitdiffstats
path: root/system/virtualxt
diff options
context:
space:
mode:
Diffstat (limited to 'system/virtualxt')
-rw-r--r--system/virtualxt/README70
-rw-r--r--system/virtualxt/slack-desc19
-rw-r--r--system/virtualxt/virtualxt.SlackBuild131
-rw-r--r--system/virtualxt/virtualxt.info10
4 files changed, 230 insertions, 0 deletions
diff --git a/system/virtualxt/README b/system/virtualxt/README
new file mode 100644
index 0000000000..afffbd9b00
--- /dev/null
+++ b/system/virtualxt/README
@@ -0,0 +1,70 @@
+VirtualXT is an IBM PC/XT (8088/V20) emulator that runs on modern
+hardware and operating systems. It is designed to be simple and
+lightweight yet still capable enough to run a large library of old
+applications and games.
+
+VirtualXT uses a module system that loads dynamic plugins, which are
+files that end with an extension of .vxt. By default, all modules will
+be built. Modules may be excluded by using the EXCLUDE_MODULES variable.
+
+For example:
+
+EXCLUDE_MODULES=network ./virtualxt.SlackBuild
+
+More than one module can be excluded as long as each module is separated
+by a comma.
+
+For example:
+
+EXCLUDE_MODULES=serial,network ./virtualxt.SlackBuild
+
+The following modules cannot be excluded:
+
+adlib
+arstech_isa
+bios
+cga
+ch36x_isa
+chipset
+covox
+ctrl
+disk
+ems
+joystick
+mouse
+rifs
+rtc
+uart
+
+The virtualxt binary is built with an SDL2 frontend and meant to be run
+by a non-root user. The user will need to be added to the "users"
+group because the binary will open the provided boot images in read-
+write mode, and "users" has write access to those images.
+
+For example:
+
+usermod -aG users bob
+
+Either the LD_LIBRARY_PATH or LD_PRELOAD variable must be configured
+to point to /usr/lib64/virtualxt. For bash users, this can be
+accomplished as follows:
+
+export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/lib64/virtualxt
+echo "export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/lib64/virtualxt" \
+ >> ~/.bashrc
+
+...or...
+
+LD_PRELOAD=/usr/lib64/virtualxt/libvxt.so virtualxt
+
+The path to the boot image must be specified when running virtualxt.
+
+For example:
+
+virtualxt -a /usr/share/virtualxt/boot/freedos.img
+
+If after upgrading from a previous version of virtualxt the console
+fails to start, then you may need to generate a new config file as
+follows:
+
+virtualxt --clean
diff --git a/system/virtualxt/slack-desc b/system/virtualxt/slack-desc
new file mode 100644
index 0000000000..35290f026b
--- /dev/null
+++ b/system/virtualxt/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+virtualxt: virtualxt (IBM PC/XT emulator)
+virtualxt:
+virtualxt: VirtualXT is an IBM PC/XT (8088/V20) emulator that runs on modern
+virtualxt: hardware and operating systems. It is designed to be simple and
+virtualxt: lightweight yet still capable enough to run a large library of old
+virtualxt: applications and games.
+virtualxt:
+virtualxt:
+virtualxt:
+virtualxt:
+virtualxt: https://phix.itch.io/virtualxt
diff --git a/system/virtualxt/virtualxt.SlackBuild b/system/virtualxt/virtualxt.SlackBuild
new file mode 100644
index 0000000000..40dc3fe8de
--- /dev/null
+++ b/system/virtualxt/virtualxt.SlackBuild
@@ -0,0 +1,131 @@
+#!/bin/bash
+
+# Slackware build script for virtualxt
+
+# Copyright 2023 Sean Eubanks <seanmeu@protonmail.com>, Cheraw, SC, USA
+# All rights reserved.
+#
+# Permission is hereby granted, free of charge, to any person obtaining a copy
+# of this software and associated documentation files (the "Software"), to
+# deal in the Software without restriction, including without limitation the
+# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
+# sell copies of the Software, and to permit persons to whom the Software is
+# furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included in
+# all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+# SOFTWARE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=virtualxt
+VERSION=${VERSION:-0.11}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+DOCS="LICENSE README.md"
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf virtualxt-$VERSION
+unzip $CWD/virtualxt-$VERSION.zip
+cd virtualxt-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+# Build virtualxt with SDL2 frontend
+which premake5
+if [ "$?" -ne 0 ]; then
+ echo "ERROR: Cannot find required premake5 binary!"
+ exit 1
+fi
+if [ -z "$EXCLUDE_MODULES" ]; then
+ # Build all modules
+ premake5 --modules gmake
+else
+ # Build all modules except those specified in EXCLUDE_MODULES
+ premake5 --modules=-$EXCLUDE_MODULES gmake
+fi
+make sdl2-frontend modules
+
+install -D -m 0755 build/bin/virtualxt $PKG/usr/bin/virtualxt
+mkdir -p $PKG/usr/lib$LIBDIRSUFFIX/virtualxt
+install -D -m 0755 build/bin/libvxt.so $PKG/usr/lib$LIBDIRSUFFIX/virtualxt/libvxt.so
+
+# Install BIOS, disk images, and modules
+DSTDIR=$PKG/usr/share/$PRGNAM
+mkdir -p $DSTDIR
+mkdir $DSTDIR/bios && cp bios/*.bin bios/*.ROM $DSTDIR/bios/
+mkdir $DSTDIR/boot && cp boot/*.img $DSTDIR/boot/
+mkdir $DSTDIR/modules && cp modules/*.vxt $DSTDIR/modules/
+
+# Allow all users read access
+if [ "$(grep ^users /etc/group)" = "" ]; then
+ echo "ERROR: The users group is missing!"
+ exit 1
+fi
+chgrp -R users $DSTDIR
+
+# All users need write access to boot images
+# otherwise image fails to boot
+chmod g+w $DSTDIR/boot/*.img
+
+# Copy README, LICENSE, and this script
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/system/virtualxt/virtualxt.info b/system/virtualxt/virtualxt.info
new file mode 100644
index 0000000000..8129787045
--- /dev/null
+++ b/system/virtualxt/virtualxt.info
@@ -0,0 +1,10 @@
+PRGNAM="virtualxt"
+VERSION="0.11"
+HOMEPAGE="https://phix.itch.io/virtualxt"
+DOWNLOAD="https://github.com/andreas-jonsson/virtualxt/archive/v0.11/virtualxt-0.11.zip"
+MD5SUM="27859bdd3a9667035a7524503d5c7c3d"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="premake5"
+MAINTAINER="Sean Eubanks"
+EMAIL="seanmeu@protonmail.com"